// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
/****************************************************************************
** XBSch}ʗvfiNX
****************************************************************************/
#ifndef XBSCHCOMPONENT_H
#define XBSCHCOMPONENT_H

#include "xbsch.h"
#include "xbschobj.h"
#include "complib.h"



//    (0) 0      (1) 90     (2) 180    (3) 270
//                                
//    s     k     a     q     
//  kq as qk sa
//    a     q     s     k     
//                                
//
//    (4) M0     (5) M90    (6) M180   (7) M270
//                                
//    s     k     a     q     
//  qk sa kq as
//    a     q     s     k     
//                                


class SXBSchComponent:public SXBSchObj
{
public:
	enum BSCHCOMP_DIR{
		COMPONENT_DIR_0		=0,
		COMPONENT_DIR_90	=1,
		COMPONENT_DIR_180	=2,
		COMPONENT_DIR_270	=3,
		COMPONENT_DIR_M0	=4,
		COMPONENT_DIR_M90	=5,
		COMPONENT_DIR_M180	=6,
		COMPONENT_DIR_M270	=7
	};

	enum BSCHCOMP_TEXTPOS{
		COMPONENT_DEFAULT_REFNUM_X	=2,
		COMPONENT_DEFAULT_REFNUM_Y	=10,
		COMPONENT_DEFAULT_NAME_X	=2,
		COMPONENT_DEFAULT_NAME_Y	=20
	};

	enum BSCHCOMP_PINLTRB{
		COMPONENT_HASLPIN	=1,
		COMPONENT_HASTPIN	=2,
		COMPONENT_HASRPIN	=4,
		COMPONENT_HASBPIN	=8,
	};

	//RXgN^
	SXBSchComponent();
	//fXgN^
	virtual ~SXBSchComponent(){}

	bool readCe3(SReadCE3&,const SPoint* ,SXBSchDoc*);
	bool writeCe3(SWriteCE3& ,const SPoint* );

    //ID̎擾
	unsigned id(){return ID_COMPONENT;}
protected:
	string	m_name;			//O
	SPoint	m_name_pos;		//Ǒ_̃ItZbg
	string	m_refnum;		//QƔԍ
	SPoint	m_refnum_pos;	//QƔԍ̌_̃ItZbg
	int		m_block;		//ubNԍ
	int		m_dir;			//
	int		m_pinltrb;		//LTRBɃs݂Ă邩ǂ̃tO
	const SCompIndex* m_compInfoIndex;	//ȉւ̃|C^
	string	m_orgname;		//璷ǁACuǂݑ˂ic߂ɕKv

protected:
	void	mirrorDir();		//m_dirϐE]
	void	rotateDir();		//m_dirϐE]
	void	resetRefnumPos();	//QƔԍ̈ʒuftHg̈ʒuɕύX
	void	resetNamePos();		//ïʒuftHg̈ʒuɕύX
	void	setPinLtrb();		//LTRBɃs݂Ă邩ǂ̃tO̐ݒ



public:
	
	SXBSchObj* duplicate();	//s
	//W̐ݒ  m_p2ւ̐ݒ𖳌ɂĂ
	void setX2(int){}
	void setY2(int){}
	void setP2(const SPoint&){}

	void move(int offsetx,int offsety);	//ʒu𓮂
	void mirrorH(int x); //XWw肵čE]s
	virtual void mirrorH(); //E]s
	void rotate(const SPoint& p); //XYSWw肵āA]s
	void rotate();	//]s
	int qSelectWeight(const SPoint& p);				//_w肵đIdvxԂ
	unsigned testSelection(const SRect& rc);		//͈͂w肵đIs
	unsigned testSelectionForDrag(const SRect& rc); //͈͂IăhbOIs
	bool qRedraw(const SRect&){return true;}		//`悪KvǂԂ qRedraw()͏ɕ`B
	
	SRect area();	//L͈͂Ԃ
	SRect bodyArea();	//L͈͂Ԃ

	SRect rotateRect();
	SSize size() const;
	SRect nameArea() const;
	SRect refnumArea() const;


public:
	void setName(const char* psz);
	const char* name() const {return m_name.c_str();}
	void setNamePos(const SPoint& p){m_name_pos = p;}
	void moveNamePos(int offsetx,int offsety);
	SPoint namePos(){return m_name_pos;}

	void setRefnum(const char* psz);
	const char* refnum() const {return m_refnum.c_str();}
	void setRefnumPos(const SPoint& p){m_refnum_pos = p;}
	void moveRefnumPos(int offsetx,int offsety);
	SPoint refnumPos(){return m_refnum_pos;}

	void setOrgName(const char* psz);
	const char* orgname() const {return m_orgname.c_str();}
	const SCompIndex* compInfoIndex() const {return m_compInfoIndex;}
	void setCompInfoIndex(const SCompIndex* pIndex);
	
	const SPin*  pinEnd(int nIndex,int& nLtrb,SPoint& ptEnd) const; //s̈ʒu擾
	SPoint pinPosition(int)	const;//nԖڂ̃s̈ʒu𓾂B
	int pinCount() const; //s̐𓾂


	void setBlock(int n);
	int block(){return m_block;}

	void setDir(int n);
	int dir(){return m_dir;}
	
	bool canAttribute(){return true;}	//Agr[g̕ύX\ȏꍇtrueԂB
};

#endif
